using MeterTelemetry.Models;
using MeterTelemetry.Services;

var builder = WebApplication.CreateBuilder(args);

builder.Services.AddScoped<TelemetryRepository>();

var app = builder.Build();

app.MapGet("/meter/telemetry", async (TelemetryRepository repo) =>
{
  return Results.Ok(await repo.GetAll());
});

app.MapGet("/meter/telemetry/fastwinds", async (TelemetryRepository repo) =>
{
  return Results.Ok(await repo.GetFastWinds());
});

app.MapGet("/meter/telemetry/{id}", async (string id, TelemetryRepository repo) =>
{
  return Results.Ok(await repo.Get(id));
});


app.MapPost("/meter/telemetry", async (Telemetry model, TelemetryRepository repo) =>
{
  var newModel = await repo.Create(model);
  return Results.Created($"/meter/telemetry/{newModel.Id}", newModel);
});

app.MapPut("/meter/telemetry/{id}", async (string id, Telemetry model, TelemetryRepository repo) =>
{
  var updated = await repo.Update(model);
  return Results.Ok(updated);
});

app.MapDelete("/meter/telemetry/{id}", async (string id, TelemetryRepository repo) =>
{
  var updated = await repo.Delete(id);
  return Results.Ok(updated);
});

app.Run();
